<template>
  <b-modal ref="theModal" :title="modalTitle" size="lg">
    <b-form @submit.prevent="onSave">
      <b-form-group label="Key">
        <b-form-input
          v-model="form.key"
          :disabled="editMode"
          trim
        ></b-form-input>
      </b-form-group>

      <b-form-group label="Type">
        <b-form-select
          v-model="form.type"
          :options="types"
          @change="checkMultiline"
        ></b-form-select>
      </b-form-group>

      <b-form-checkbox
        v-model="form.multiline"
        :value="true"
        :unchecked-value="false"
        :disabled="!canMultiline"
      >
        multiline
      </b-form-checkbox>

      <div v-if="canPlaceholder">
        <hr />

        <b-form-group label="Placeholders">
          <div>
            <b-badge
              v-for="placeholder in form.placeholders"
              :key="placeholder"
              variant="light"
              class="m-1"
              style="font-size: medium;"
              >&#123; {{ placeholder }} &#125;
              <b-button
                @click="removePlaceholder(placeholder)"
                size="sm"
                variant="danger"
                >x</b-button
              ></b-badge
            >
          </div>

          <div class="d-flex justify-content-start mt-2">
            <b-input
              v-model="placeholderForm.value"
              style="max-width: 125px;"
              trim
            ></b-input>
            <b-button
              @click="addPlaceholder"
              :disabled="!validPlaceholder"
              class="ml-2"
              variant="success"
              >add</b-button
            >
          </div>
        </b-form-group>
      </div>

      <hr />

      <b-form-group label="Hint (give example etc.)">
        <b-form-input v-model="form.translationHint" trim></b-form-input>
      </b-form-group>

      <div v-if="!editMode">
        <b-form-group :label="initTranslationLabel">
          <b-form-input
            v-model="form.initialTranslation"
            v-if="!form.multiline"
          ></b-form-input>
          <b-textarea v-model="form.initialTranslation" v-else></b-textarea>
        </b-form-group>
      </div>
    </b-form>

    <template v-slot:modal-footer>
      <b-form-checkbox
        v-model="createAnother"
        :value="true"
        :unchecked-value="false"
      >
        create another
      </b-form-checkbox>
      <b-button @click="onCancel" variant="danger">CANCEL</b-button>
      <b-button
        @click="onSave"
        :disabled="!isValidForm"
        variant="success"
        class="ml-2"
        >SAVE</b-button
      >
    </template>
  </b-modal>
</template>

<script>
import BrickType from '../enumeration/BrickType';
export default {
  props: {
    defaultLanguage: {
      type: String,
      require: true,
    },
  },
  data() {
    return {
      brick: null,
      createAnother: false,
      placeholderForm: {
        value: '',
      },
      form: {
        placeholders: [],
      },
      formDefault: {
        key: '',
        translationHint: '',
        type: BrickType.PLAIN,
        multiline: false,
        initialTranslation: '',
        placeholders: [],
      },
      types: [
        { value: BrickType.PLAIN, text: 'Simple Text' },
        { value: BrickType.PLURAL, text: 'Pluralization' },
        { value: BrickType.MARKDOWN, text: 'Markdown' },
      ],
    };
  },
  computed: {
    modalTitle() {
      let title = 'New brick';
      if (this.brick) {
        title = 'Edit: ' + this.brick.key;
      }

      return title;
    },
    editMode() {
      return this.brick;
    },
    isValidForm() {
      return this.form.key.length > 4;
    },
    canPlaceholder() {
      return this.form.type !== BrickType.PLURAL;
    },
    canMultiline() {
      return this.form.type !== BrickType.PLURAL;
    },
    initTranslationLabel() {
      return 'Initial translation (' + this.defaultLanguage + ')';
    },
    validPlaceholder() {
      return (
        this.placeholderForm.value &&
        this.placeholderForm.value.trim() !== '' &&
        !this.form.placeholders.some((entry) => {
          return entry === this.placeholderForm.value;
        })
      );
    },
  },
  mounted() {
    this.resetForm();
  },
  methods: {
    addPlaceholder() {
      if (this.validPlaceholder) {
        this.form.placeholders.push(this.placeholderForm.value);
        this.placeholderForm.value = '';
      }
    },
    removePlaceholder(placeholder) {
      this.form.placeholders = this.form.placeholders.filter((entry) => {
        return entry !== placeholder;
      });
    },
    checkMultiline() {
      this.$nextTick(() => {
        if (!this.canMultiline) {
          this.form.multiline = false;
        }
      });
    },
    resetForm() {
      this.form = JSON.parse(JSON.stringify(this.formDefault));
    },
    show(brick) {
      this.resetForm();

      if (brick) {
        this.brick = brick;

        this.form.key = brick.key;
        this.form.translationHint = brick.translationHint;
        this.form.type = brick.type;
        this.form.multiline = brick.multiline;
        this.form.placeholders = brick.placeholders;
      } else {
        this.brick = null;
      }

      this.$refs.theModal.show();
    },
    hide() {
      this.$refs.theModal.hide();
    },
    toggle() {
      this.$refs.theModal.toggle();
    },
    onCancel() {
      this.hide();
    },
    onSave() {
      if (this.isValidForm) {
        this.$emit('save', this.brick, this.form, this.createAnother);
      }
    },
  },
};
</script>
